    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ------------
    028 * Dataset.java
    029 * ------------
    030 * (C) Copyright 2000-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes (from 18-Sep-2001)
    036 * --------------------------
    037 * 18-Sep-2001 : Added standard header and fixed DOS encoding problem (DG);
    038 * 15-Oct-2001 : Moved to a new package (com.jrefinery.data.*) (DG);
    039 * 22-Oct-2001 : Changed name to Dataset.java (DG);
    040 * 17-Nov-2001 : Added getLegendItemCount() and getLegendItemLabels() methods,
    041 *               created SeriesDataset interface and transferred series related
    042 *               methods out (DG);
    043 * 22-Jan-2002 : Reconsidered (and removed) the getLegendItemCount() and
    044 *               getLegendItemLabels() methods...leave this to client code (DG);
    045 * 27-Sep-2002 : Added get/setDatasetGroup() methods (DG);
    046 * 10-Jan-2003 : Updated Javadocs (DG);
    047 *
    048 */
    049
    050package org.jfree.data.general;
    051
    052/**
    053 * The base interface for data sets.
    054 * <P>
    055 * All datasets are required to support the {@link DatasetChangeEvent}
    056 * mechanism by allowing listeners to register and receive notification of any
    057 * changes to the dataset.
    058 * <P>
    059 * In addition, all datasets must belong to one (and only one)
    060 * {@link DatasetGroup}.  The group object maintains a reader-writer lock
    061 * which provides synchronised access to the datasets in multi-threaded code.
    062 */
    063public interface Dataset {
    064
    065    /**
    066     * Registers an object for notification of changes to the dataset.
    067     *
    068     * @param listener  the object to register.
    069     */
    070    public void addChangeListener(DatasetChangeListener listener);
    071
    072    /**
    073     * Deregisters an object for notification of changes to the dataset.
    074     *
    075     * @param listener  the object to deregister.
    076     */
    077    public void removeChangeListener(DatasetChangeListener listener);
    078
    079    /**
    080     * Returns the dataset group.
    081     *
    082     * @return The dataset group.
    083     */
    084    public DatasetGroup getGroup();
    085
    086    /**
    087     * Sets the dataset group.
    088     *
    089     * @param group  the dataset group.
    090     */
    091    public void setGroup(DatasetGroup group);
    092
    093}